/*
  I2C Arduino Modüllerinin Adres Numarası Nasıl Bulunur?
 
  I2C veri iletişim protokolünün detaylı açıklaması ve örnek projelerini
  web sitemizde bulabilirsiniz.
 
  Mete Hoca
  https://www.metehoca.com/
*/

#include "Wire.h"              // I2C'yi kullanan dahili kütüphaneyi ekliyoruz

int hata, adres, cihaz_sayisi; // Değişkenlerimizi tanımlıyoruz

void setup() {
  Wire.begin();                // Wire kütüphanesi başlatılıyor
  Serial.begin(9600);          // Seri Port Ekranı başlatılıyor
}

void loop() {
  cihaz_sayisi = 0;
  for (adres = 1; adres < 127; adres++ ) { // Tüm adresler taranıyor
    Wire.beginTransmission(adres);
    hata = Wire.endTransmission();

    if (hata == 0) {                     // Bulunan cihazı görüntüleyelim
      Serial.print("I2C cihaz bulundu! | Adres: 0x");
      if (adres < 16) Serial.print("0"); // Cihaz adresi tek hane ise başına 0 koyalım
      Serial.println(adres, HEX);
      cihaz_sayisi++;
    }
    else 
      if (hata == 4) {                   // Bu adreste bilinmeyen bir hata oluştu
        Serial.print("Bu adreste bilinmeyen bir hata oluştu: 0x");
        if (adres < 16) Serial.print("0");
        Serial.println(adres, HEX);
      }
  }
  if (cihaz_sayisi == 0)                 // Hiçbir cihaz bulunamadı
    Serial.println("Hiçbir I2C cihaz bulunamadı...");
  delay(3000);
}
